from syntax import *
from interval_analysis import state, abstract_env, Interval, reduce_state

x: ArithExpr = AEVar("x")
y: ArithExpr = AEVar("y")

test_eq: BoolExpr = BEEq(x,y)

test_neq: BoolExpr = BENeg(test_eq)

test_leq: BoolExpr = BELeq(x,y)

test_gt: BoolExpr = BENeg(test_leq)

def env_str(env: abstract_env) -> str:
    return '{ ' + ', '.join([ f'{var}: {i}' for (var,i) in env.items()]) + ' }'

def state_str(env: state) -> str:
    if env is None: return 'None'
    return env_str(env)

def test(env: abstract_env) -> None:
    res_eq = reduce_state(env,test_eq)
    res_neq = reduce_state(env,test_neq)
    res_leq = reduce_state(env,test_leq)
    res_gt = reduce_state(env,test_gt)
    print(f'In environment { env_str(env) }')
    print(f"{test_eq} -> {state_str(res_eq)}")
    print(f"{test_neq} -> {state_str(res_neq)}")
    print(f"{test_leq} -> {state_str(res_leq)}")
    print(f"{test_gt} -> {state_str(res_gt)}")

test({ 'x': Interval(0,5), 'y': Interval(-5,0) })

test({ 'x': Interval(-5,5), 'y': Interval(3,7) })

test({ 'x': Interval(0,5), 'y': Interval(-10,-5) })

test({ 'x': Interval(0,0), 'y': Interval(0,4) })
